Index: trunk/source/processes/hadronic/cross_sections/src/G4PhotoNuclearCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4PhotoNuclearCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4PhotoNuclearCrossSection.cc	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // The lust update: M.V. Kossov, CERN/ITEP(Moscow) 17-June-02
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 //
@@ -40,4 +40,5 @@
 
 #include "G4PhotoNuclearCrossSection.hh"
+#include "G4HadTmpUtil.hh"
 
 // Initialization of the statics
@@ -59,10 +60,15 @@
                             // Last value of the ShadowingPomeron (A-dependent)
 
-std::vector<G4double*> G4PhotoNuclearCrossSection::GDR;   // Vector of pointers to the GDRPhotonuclearCrossSection
-std::vector<G4double*> G4PhotoNuclearCrossSection::HEN;   // Vector of pointers to the HighEnPhotonuclearCrossSect
+
+// Vector of pointers to the GDRPhotonuclearCrossSection
+std::vector<G4double*> G4PhotoNuclearCrossSection::GDR;
+
+// Vector of pointers to the HighEnPhotonuclearCrossSect
+std::vector<G4double*> G4PhotoNuclearCrossSection::HEN;
+
 
 G4PhotoNuclearCrossSection::G4PhotoNuclearCrossSection()
-{
-}
+{}
+
 
 G4PhotoNuclearCrossSection::~G4PhotoNuclearCrossSection()
@@ -92,10 +98,10 @@
     G4IsotopeVector* isoVector = anEle->GetIsotopeVector();
     G4double* abundVector = anEle->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
   
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
       psig = GetIsoZACrossSection(aPart, ZZ, AA, temperature);
       cross_section += psig*abundVector[i];
@@ -103,6 +109,7 @@
 
   } else {
-    cross_section = 
-      GetIsoZACrossSection(aPart, anEle->GetZ(), anEle->GetN(), temperature);
+    G4int ZZ = G4lrint(anEle->GetZ());
+    G4int AA = G4lrint(anEle->GetN());
+    cross_section = GetZandACrossSection(aPart, ZZ, AA, temperature);
   }
  
@@ -112,6 +119,6 @@
 
 G4double 
-G4PhotoNuclearCrossSection::GetIsoZACrossSection(const G4DynamicParticle* aPart,
-                                                 G4double ZZ, G4double AA, 
+G4PhotoNuclearCrossSection::GetZandACrossSection(const G4DynamicParticle* aPart,
+                                                 G4int ZZ, G4int AA, 
 					         G4double /*temperature*/)
 {
@@ -146,6 +153,6 @@
   //
   const G4double Energy = aPart->GetKineticEnergy()/MeV;
-  const G4int targetAtomicNumber = static_cast<int>(AA+.499); //@@ Nat mixture (?!)
-  const G4int targZ = static_cast<int>(ZZ);
+  const G4int targetAtomicNumber = AA; //@@ Nat mixture (?!)
+  const G4int targZ = ZZ;
   const G4int targN = targetAtomicNumber-targZ;
 #ifdef debug
@@ -1609,9 +1616,9 @@
 
   static const G4double SH10[nH]={
-    3.918292e+00,3.904931e+00,3.893792e+00,3.886847e+00,3.886858e+00,3.897612e+00,3.924175e+00,
-    3.973155e+00,4.052892e+00,4.173448e+00,4.346251e+00,4.583168e+00,4.894929e+00,5.289011e+00,
-    5.767472e+00,6.325587e+00,6.952077e+00,7.631192e+00,8.346046e+00,9.081993e+00,9.828955e+00,
-    1.058224e+01,1.134205e+01,1.211228e+01,1.289914e+01,1.370979e+01,1.455140e+01,1.543028e+01,
-    1.635126e+01,1.731704e+01,1.832759e+01,1.937949e+01,2.046524e+01,2.157253e+01,2.268371e+01,
+    3.918292, 3.904931, 3.893792, 3.886847, 3.886858, 3.897612, 3.924175,
+    3.973155, 4.052892, 4.173448, 4.346251, 4.583168, 4.894929, 5.289011,
+    5.767472, 6.325587, 6.952077, 7.631192, 8.346046, 9.081993, 9.828955,
+   10.58224, 11.34205, 12.11228, 12.89914, 13.70979, 14.55140, 15.43028,
+   16.35126, 17.31704, 18.32759, 19.37949, 20.46524, 21.57253, 22.68371,
     2.377554e+01,2.481942e+01,2.578236e+01,2.662884e+01,2.732355e+01,2.783477e+01,2.813791e+01,
     2.821866e+01,2.807489e+01,2.771701e+01,2.716665e+01,2.645395e+01,2.561414e+01,2.468397e+01,
Index: trunk/source/processes/hadronic/cross_sections/src/G4PiNuclearCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4PiNuclearCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4PiNuclearCrossSection.cc	(revision 1340)
@@ -75,5 +75,5 @@
  const G4double G4PiNuclearCrossSection::e2[39] = {
   .02, .04, .06, .08, .10, .11, .12, .13, .14,  .15, .16, .17, .18, .20, .22,
-  .24, .26, .28, .30, .35, .40, .45, .50, .55, .575, .60, .70, .80, .90,   1,   
+  .24, .26, .28, .30, .35, .40, .45, .50, .55, .575, .60, .70, .80, .90,   1,
     2,   3,   5,  10,  20,  50, 100, 500, 100000};
 
@@ -138,7 +138,7 @@
 
  const G4double G4PiNuclearCrossSection::na_m_t[31] = {
-  450, 545, 705, 910, 1020, 1075, 1087, 1080, 1042, 987, 943, 885, 790, 700, 650, 
-  610, 585, 575, 585,  595,  600,  610,  556,  524, 494, 458, 445, 429, 427, 427,
-  427};
+  450, 545, 705, 910, 1020, 1075, 1087, 1080, 1042, 987, 943, 885, 790, 700,
+  650, 610, 585, 575, 585,  595,  600,  610,  556,  524, 494, 458, 445, 429,
+  427, 427, 427};
 
  const G4double G4PiNuclearCrossSection::na_m_in[31] = {
@@ -156,12 +156,12 @@
 
  const G4double G4PiNuclearCrossSection::e3_1[31] = { 
-  0.02, 0.04, 0.06, 0.08, 0.10, 0.12, 0.14, 0.16, 0.18, 0.20, 0.22, 0.25, 0.30, 0.35, 0.40,
-  0.45, 0.50, 0.60, 0.70, 0.80, 0.90,    1,    2,    3,    5,   10,   20,   50,  100,  500,
-  100000};
+  0.02, 0.04, 0.06, 0.08, 0.10, 0.12, 0.14, 0.16, 0.18, 0.20,
+  0.22, 0.25, 0.30, 0.35, 0.40, 0.45, 0.50, 0.60, 0.70, 0.80,
+  0.90, 1.0,  2.0,  3.0,  5.0, 10.0, 20.0, 50.0, 100.0, 500.0, 100000.0};
 
  const G4double G4PiNuclearCrossSection::al_m_t[31] = { 
-  532, 637, 832, 1057, 1207, 1230, 1210, 1174, 1133, 1095, 1038, 970, 890, 807, 750, 
-  710, 675, 665,  670,  673,  678,  682,  618,  574,  546,  520, 507, 495, 488, 488,  
-  488};
+  532, 637, 832, 1057, 1207, 1230, 1210, 1174, 1133, 1095,
+ 1038, 970, 890,  807,  750,  710,  675,  665,  670,  673,
+  678, 682, 618,  574,  546,  520,  507,  495,  488,  488,  488};
 
  const G4double G4PiNuclearCrossSection::al_m_in[31] = {
@@ -171,6 +171,6 @@
 
  const G4double G4PiNuclearCrossSection::al_p_t[21] = { 
-  225, 350, 616, 945, 1122, 1175, 1157, 1128, 1088, 1045, 988, 935, 870, 787, 730, 
-  690, 660, 652, 660,  668,  678};
+  225, 350, 616, 945, 1122, 1175, 1157, 1128, 1088, 1045,
+  988, 935, 870, 787, 730,   690,  660,  652,  660,  668,  678};
 
  const G4double G4PiNuclearCrossSection::al_p_in[21] = {
@@ -179,7 +179,7 @@
 
  const G4double G4PiNuclearCrossSection::ca_m_t[31] = { 
-  800, 980, 1240, 1460, 1570, 1600, 1580, 1535, 1475, 1425, 1375, 1295, 1200, 1083, 1000, 
-  948, 915,  895,  900,  908,  915,  922,  856,  795,  740,  705,  682,  660,  660,  660,
-  660};
+  800,  980, 1240, 1460, 1570, 1600, 1580, 1535, 1475, 1425,
+ 1375, 1295, 1200, 1083, 1000,  948,  915,  895,  900,  908,
+  915,  922,  856,  795,  740,  705,  682,  660,  660,  660, 660};
 
  const G4double G4PiNuclearCrossSection::ca_m_in[31] = {
@@ -222,14 +222,33 @@
  const G4double G4PiNuclearCrossSection::cd_m_t[34] = {3060, 3125, 3170, 3220, 3255, 3280, 3290, 3260, 3270, 3200, 3120, 3080, 3090, 2920, 2810, 2640, 2362, 2230, 2115, 2050, 2020, 2025, 2040, 2070, 2100, 1900, 1795, 1740, 1675, 1645, 1625, 1620, 1620, 1620};
  const G4double G4PiNuclearCrossSection::cd_m_in[34]= {1025, 1275, 1440, 1625, 1740, 1800, 1880, 1920, 1980, 1920, 1850, 1810, 1720, 1650, 1560, 1450, 1330, 1290, 1245, 1210, 1200, 1200, 1205, 1205, 1230, 1130, 1085, 1060, 1000,  985,  975,  970,  970,  970};
- const G4double G4PiNuclearCrossSection::cd_p_t[28] =  {455,  780, 1170, 1700, 2120, 2400, 2600, 2720, 2820, 2840, 2800, 2760, 2720, 2640, 2560, 2450, 2252, 2130, 2035, 1985, 1970, 1975, 2005, 2035, 2070, 1880, 1795, 1740};
- const G4double G4PiNuclearCrossSection::cd_p_in[28] = {310,  580,  880, 1060, 1270, 1400, 1530, 1610, 1660, 1680, 1640, 1600, 1560, 1500, 1430, 1330, 1280, 1230, 1200, 1180, 1170, 1175, 1180, 1180, 1210, 1120, 1085, 1060};
+
+ const G4double G4PiNuclearCrossSection::cd_p_t[28] =  {
+   455,  780, 1170, 1700, 2120, 2400, 2600, 2720, 2820, 2840,
+  2800, 2760, 2720, 2640, 2560, 2450, 2252, 2130, 2035, 1985,
+  1970, 1975, 2005, 2035, 2070, 1880, 1795, 1740};
+
+ const G4double G4PiNuclearCrossSection::cd_p_in[28] = {
+   310,  580,  880, 1060, 1270, 1400, 1530, 1610, 1660, 1680,
+  1640, 1600, 1560, 1500, 1430, 1330, 1280, 1230, 1200, 1180,
+  1170, 1175, 1180, 1180, 1210, 1120, 1085, 1060};
 
  const G4double G4PiNuclearCrossSection::e6[35] = {
-  0.02, 0.04, 0.05, 0.06, 0.07, 0.08, 0.09, 0.10, 0.12, 0.14, 0.16, 0.18, 0.20, 0.22, 0.25,  
-  0.30, 0.35, 0.40, 0.45, 0.50, 0.55, 0.60, 0.70, 0.80, 0.90,    1,    2,    3,    5,   10,   
-    20,   50,  100,  500, 100000};
-
- const G4double G4PiNuclearCrossSection::sn_m_t[35] =  {3000, 3180, 3250, 3300, 3300, 3410, 3470, 3450, 3410, 3350, 3280, 3200, 3120, 3050, 2900, 2630, 2500, 2325, 2190, 2100, 2060, 2055, 2055, 2055, 2067, 2085, 2000, 1900, 1835, 1770, 1720, 1700, 1695, 1695, 1695};
- const G4double G4PiNuclearCrossSection::sn_m_in[35] = {1050, 1350, 1520, 1650, 1800, 1980, 2070, 2120, 2090, 2050, 1980, 1920, 1830, 1770, 1670, 1500, 1435, 1350, 1300, 1230, 1220, 1235, 1235, 1235, 1237, 1240, 1160, 1120, 1090, 1065, 1040, 1020, 1015, 1015, 1015};
+  0.02, 0.04, 0.05, 0.06, 0.07, 0.08, 0.09, 0.10, 0.12, 0.14,
+  0.16, 0.18, 0.20, 0.22, 0.25, 0.30, 0.35, 0.40, 0.45, 0.50,
+  0.55, 0.60, 0.70, 0.80, 0.90, 1.0,  2.0,  3.0,  5.0, 10.0,   
+ 20.0, 50.0, 100.0, 500.0, 100000.0};
+
+ const G4double G4PiNuclearCrossSection::sn_m_t[35] = {
+  3000, 3180, 3250, 3300, 3300, 3410, 3470, 3450, 3410, 3350,
+  3280, 3200, 3120, 3050, 2900, 2630, 2500, 2325, 2190, 2100,
+  2060, 2055, 2055, 2055, 2067, 2085, 2000, 1900, 1835, 1770,
+  1720, 1700, 1695, 1695, 1695};
+
+ const G4double G4PiNuclearCrossSection::sn_m_in[35] = {
+  1050, 1350, 1520, 1650, 1800, 1980, 2070, 2120, 2090, 2050,
+  1980, 1920, 1830, 1770, 1670, 1500, 1435, 1350, 1300, 1230,
+  1220, 1235, 1235, 1235, 1237, 1240, 1160, 1120, 1090, 1065,
+  1040, 1020, 1015, 1015, 1015};
+
  const G4double G4PiNuclearCrossSection::sn_p_t[29] =  { 465,  800, 1200, 1760, 2170, 2480, 2730, 2885, 2970, 2980, 2970, 2890, 2840, 2790, 2620, 2450, 2335, 2205, 2080, 2020, 2010, 1990, 1990, 2015, 2030, 2045, 1980, 1890, 1835};
  const G4double G4PiNuclearCrossSection::sn_p_in[29] = { 315,  590,  880, 1220, 1460, 1580, 1700, 1770, 1810, 1810, 1800, 1730, 1680, 1630, 1530, 1400, 1335, 1270, 1210, 1180, 1190, 1190, 1190, 1205, 1210, 1210, 1150, 1115, 1090};
@@ -346,9 +365,8 @@
 
 G4double G4PiNuclearCrossSection::
-GetIsoZACrossSection(const G4DynamicParticle* particle, G4double ZZ, 
-                     G4double /*AA*/, G4double /*temperature*/)
+GetZandACrossSection(const G4DynamicParticle* particle, G4int ZZ, 
+                     G4int /*AA*/, G4double /*temperature*/)
 {
   // precondition
-  //  G4ping debug("debug_PiNuclearCrossSection");
   using namespace std;
   G4bool ok = false;
@@ -367,9 +385,9 @@
 
   G4double result = 0;
-  G4int Z=G4lrint(ZZ);
+  G4int Z = ZZ;
   //  debug.push_back(Z);
   size_t it = 0;
 
-  while(it<theZ.size() && Z>theZ[it]) it++;
+  while(it < theZ.size() && Z > theZ[it]) it++;
 
   //  debug.push_back(theZ[it]);
@@ -475,19 +493,21 @@
  }
 
- G4double G4PiNuclearCrossSection::
- Interpolate(G4int Z1, G4int Z2, G4int Z, G4double x1, G4double x2)
- { 
+
+G4double G4PiNuclearCrossSection::
+Interpolate(G4int Z1, G4int Z2, G4int Z, G4double x1, G4double x2)
+{ 
 //   Nucleon numbers obtained from G4NistManager G4 8.0
- static const G4double A[92]=
- 			{1.0001, 4.0000, 6.9241, 9.0000, 10.801, 12.011, 14.004, 16.004, 19.000, 20.188,
-			 23.000, 24.320, 27.000, 28.109, 31.000, 32.094, 35.484, 39.985, 39.135, 40.116,
-			 45.000, 47.918, 50.998, 52.055, 55.000, 55.910, 59.000, 58.760, 63.617, 65.468,
-			 69.798, 72.691, 75.000, 79.042, 79.986, 83.887, 85.557, 87.710, 89.000, 91.318,
-			 93.000, 96.025, 98.000, 101.16, 103.00, 106.51, 107.96, 112.51, 114.91, 118.81,
-			 121.86, 127.70, 127.00, 131.39, 133.00, 137.42, 139.00, 140.21, 141.00, 144.32,
-			 145.00, 150.45, 152.04, 157.33, 159.00, 162.57, 165.00, 167.32, 169.00, 173.10,
-			 175.03, 178.54, 181.00, 183.89, 186.25, 190.27, 192.25, 195.11, 197.00, 200.63,
-			 204.41, 207.24, 209.00, 209.00, 210.00, 222.00, 223.00, 226.00, 227.00, 232.00,
-			 231.00, 237.98};
+ static const G4double A[92] = {
+   1.0001, 4.0000, 6.9241, 9.000, 10.801, 12.011, 14.004, 16.004, 19.000,
+  20.188, 23.000, 24.320, 27.000, 28.109, 31.000, 32.094, 35.484, 39.985,
+  39.135, 40.116, 45.000, 47.918, 50.998, 52.055, 55.000, 55.910, 59.000,
+  58.760, 63.617, 65.468, 69.798, 72.691, 75.000, 79.042, 79.986, 83.887,
+  85.557, 87.710, 89.000, 91.318, 93.000, 96.025, 98.000, 101.16, 103.00,
+ 106.51, 107.96, 112.51, 114.91, 118.81, 121.86, 127.70,  127.00, 131.39,
+ 133.00, 137.42, 139.00, 140.21, 141.00, 144.32, 145.00,  150.45, 152.04,
+ 157.33, 159.00, 162.57, 165.00, 167.32, 169.00, 173.10,  175.03, 178.54,
+ 181.00, 183.89, 186.25, 190.27, 192.25, 195.11, 197.00, 200.63,  204.41,
+ 207.24, 209.00, 209.00, 210.00, 222.00, 223.00, 226.00, 227.00,  232.00,
+ 231.00, 237.98};
 			 
  static G4bool NeedInit=true;		     
@@ -502,10 +522,10 @@
  }
 
-//        for tabulated data, cross section scales with A^.75
+// for tabulated data, cross section scales with A^.75
    G4double r1 = x1 / A75[Z1-1] * A75[Z-1];
    G4double r2 = x2 / A75[Z2-1] * A75[Z-1];
    G4double result=0.5*(r1+r2);
-//       G4cout << "x1/2, z1/2 z" <<x1<<" "<<x2<<" "<<Z1<<" "<<Z2<<" "<<Z<<G4endl;
-//       G4cout << "res1/2 " << r1 <<" " << r2 <<" " << result<< G4endl;
+//  G4cout << "x1/2, z1/2 z" <<x1<<" "<<x2<<" "<<Z1<<" "<<Z2<<" "<<Z<<G4endl;
+//  G4cout << "res1/2 " << r1 <<" " << r2 <<" " << result<< G4endl;
    return result;
- }
+}
Index: trunk/source/processes/hadronic/cross_sections/src/G4ProtonInelasticCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4ProtonInelasticCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4ProtonInelasticCrossSection.cc	(revision 1340)
@@ -31,4 +31,5 @@
 
 #include "G4ProtonInelasticCrossSection.hh"
+#include "G4HadTmpUtil.hh"
 #include "globals.hh"
 
@@ -46,10 +47,10 @@
     G4IsotopeVector* isoVector = anEle->GetIsotopeVector();
     G4double* abundVector = anEle->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
  
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
       psig = GetCrossSection(KE, AA, ZZ);
       cross_section += psig*abundVector[i];
@@ -57,5 +58,7 @@
  
   } else {
-    cross_section = GetCrossSection(KE, anEle->GetN(), anEle->GetZ());
+    G4int ZZ = G4lrint(anEle->GetZ());
+    G4int AA = G4lrint(anEle->GetN());
+    cross_section = GetCrossSection(KE, AA, ZZ);
   }
 
@@ -63,7 +66,7 @@
 }
 
-   
+
 G4double G4ProtonInelasticCrossSection::
-GetCrossSection(G4double kineticEnergy, G4double atomicNumber, G4double nOfProtons)
+GetCrossSection(G4double kineticEnergy, G4int atomicNumber, G4int nOfProtons)
 {   
   if (kineticEnergy > 19.9*GeV ) 
@@ -71,5 +74,5 @@
     return  GetCrossSection(19.8*GeV,atomicNumber,nOfProtons);
   } 
-  G4double nOfNeutrons = atomicNumber-nOfProtons;
+  G4int nOfNeutrons = atomicNumber-nOfProtons;
   kineticEnergy /=GeV;
   G4double a = atomicNumber;
@@ -80,5 +83,5 @@
   G4double fac1=b0*(1-std::pow(a,-0.3333));
   G4double fac2=1.;
-  if(nOfNeutrons>1.5) fac2=std::log((nOfNeutrons));
+  if(nOfNeutrons > 1) fac2=std::log((G4double(nOfNeutrons)));
   G4double crossSection = 1E31*fac*fac2*(1+std::pow(a,0.3333)-fac1);
 
Index: trunk/source/processes/hadronic/cross_sections/src/G4TripathiCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4TripathiCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4TripathiCrossSection.cc	(revision 1340)
@@ -43,9 +43,8 @@
 
 G4double G4TripathiCrossSection::
-GetIsoZACrossSection(const G4DynamicParticle* aPart, G4double ZZ, G4double AA, 
-                G4double /*temperature*/) 
+GetZandACrossSection(const G4DynamicParticle* aPart, G4int ZZ, G4int AA, 
+                     G4double /*temperature*/) 
 {
   G4double result = 0.;
-  
   const G4double targetAtomicNumber = AA;
   const G4double nTargetProtons = ZZ;
@@ -157,18 +156,18 @@
     G4IsotopeVector* isoVector = anEle->GetIsotopeVector();
     G4double* abundVector = anEle->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
      
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
-      sig = GetIsoZACrossSection(aPart, ZZ, AA, temperature);
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
+      sig = GetZandACrossSection(aPart, ZZ, AA, temperature);
       xsection += sig*abundVector[i];
     }
    
   } else {
-    xsection =
-      GetIsoZACrossSection(aPart, anEle->GetZ(), anEle->GetN(),
-                           temperature);
+    G4int ZZ = G4lrint(anEle->GetZ());
+    G4int AA = G4lrint(anEle->GetN());
+    xsection = GetIsoZACrossSection(aPart, ZZ, AA, temperature);
   }
 
Index: trunk/source/processes/hadronic/cross_sections/src/G4TripathiLightCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4TripathiLightCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4TripathiLightCrossSection.cc	(revision 1340)
@@ -63,4 +63,6 @@
 #include "G4ParticleTable.hh"
 #include "G4IonTable.hh"
+#include "G4HadTmpUtil.hh"
+
 
 ///////////////////////////////////////////////////////////////////////////////
@@ -101,10 +103,13 @@
   (const G4DynamicParticle* theProjectile, const G4Element* theTarget)
 {
-  return IsZAApplicable(theProjectile, theTarget->GetZ(), theTarget->GetN());
-}
-
-
-G4bool G4TripathiLightCrossSection::IsZAApplicable
-  (const G4DynamicParticle* theProjectile, G4double ZZ, G4double AA)
+  G4int Z = G4lrint(theTarget->GetZ());
+  G4int A = G4lrint(theTarget->GetN());
+  return IsIsoApplicable(theProjectile, Z, A);
+}
+
+
+G4bool
+G4TripathiLightCrossSection::IsIsoApplicable(const G4DynamicParticle* theProjectile,
+                                             G4int ZZ, G4int AA)
 {
   G4bool result = false;
@@ -122,9 +127,10 @@
   return result;
 }
-///////////////////////////////////////////////////////////////////////////////
-//
-G4double G4TripathiLightCrossSection::GetIsoZACrossSection
-  (const G4DynamicParticle* theProjectile, G4double ZZ, G4double AA,
-   G4double /*theTemperature*/)
+
+///////////////////////////////////////////////////////////////////////////////
+//
+G4double
+G4TripathiLightCrossSection::GetZandACrossSection(const G4DynamicParticle* theProjectile,
+                                                  G4int ZZ, G4int AA, G4double /*theTemperature*/)
 {
 //
@@ -301,5 +307,5 @@
 	  SetLowEnergyCheck(true);
       G4double resultp =
-        GetIsoZACrossSection(&slowerProjectile, ZZ, AA, 0.0);
+        GetZandACrossSection(&slowerProjectile, ZZ, AA, 0.0);
 	  SetLowEnergyCheck(savelowenergy);
       if (resultp >result) result = 0.0;
@@ -322,18 +328,18 @@
     G4IsotopeVector* isoVector = theTarget->GetIsotopeVector();
     G4double* abundVector = theTarget->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
      
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
-      sig = GetIsoZACrossSection(theProjectile, ZZ, AA, theTemperature);
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
+      sig = GetZandACrossSection(theProjectile, ZZ, AA, theTemperature);
       xsection += sig*abundVector[i];
     }
    
   } else {
-    xsection =
-      GetIsoZACrossSection(theProjectile, theTarget->GetZ(), theTarget->GetN(),
-                           theTemperature);
+    G4int ZZ = G4lrint(theTarget->GetZ());
+    G4int AA = G4lrint(theTarget->GetN());
+    xsection = GetIsoZACrossSection(theProjectile, ZZ, AA, theTemperature);
   }
     
@@ -348,4 +354,3 @@
   lowEnergyCheck = aLowEnergyCheck;
 }
-///////////////////////////////////////////////////////////////////////////////
-//
+
Index: trunk/source/processes/hadronic/cross_sections/src/G4UElasticCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4UElasticCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4UElasticCrossSection.cc	(revision 1340)
@@ -80,6 +80,8 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-G4bool G4UElasticCrossSection::IsZAApplicable(const G4DynamicParticle* dp, 
-						G4double Z, G4double A)
+// G4bool G4UElasticCrossSection::IsZAApplicable(const G4DynamicParticle* dp, 
+// 						G4double Z, G4double A)
+G4bool G4UElasticCrossSection::IsIsoApplicable(const G4DynamicParticle* dp,
+                                               G4int Z, G4int A)
 {
   G4bool res = false;
@@ -94,30 +96,30 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4UElasticCrossSection::GetCrossSection(const G4DynamicParticle* dp, 
-						   const G4Element* elm, 
-						   G4double temp)
-{
-  return GetIsoZACrossSection(dp, elm->GetZ(), elm->GetN(), temp);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4UElasticCrossSection::GetIsoZACrossSection(const G4DynamicParticle* dp, 
-							G4double Z,
-							G4double A, 
-							G4double)
+
+G4double
+G4UElasticCrossSection::GetCrossSection(const G4DynamicParticle* dp, 
+                                        const G4Element* elm, G4double temp)
+{
+  G4int Z = G4lrint(elm->GetZ());
+  G4int N = G4lrint(elm->GetN());
+
+  return GetZandACrossSection(dp, Z, N, temp);
+}
+
+
+G4double
+G4UElasticCrossSection::GetZandACrossSection(const G4DynamicParticle* dp, 
+                                             G4int Z, G4int A, G4double)
 {
   G4double cross = 0.0;
   G4double ekin = dp->GetKineticEnergy();
-  G4int iz = G4int(Z);
-  if(iz > 92) iz = 92;
+//  G4int iz = G4int(Z);
+  if(Z > 92) Z = 92;
 
     // proton and neutron
   if(fNucleon) { 
-    if(iz == 1) cross = fGheisha->GetElasticCrossSection(dp, Z, A);
+    if(Z == 1) cross = fGheisha->GetElasticCrossSection(dp, Z, A);
     else if(ekin > thEnergy) {
-      cross = theFac[iz]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
+      cross = theFac[Z]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
     } else {
       cross = fNucleon->GetElasticCrossSection(dp, Z, A);
@@ -126,7 +128,7 @@
     // pions
   } else if(fUPi) {
-    if(iz == 1) cross = fGheisha->GetElasticCrossSection(dp, Z, A);
+    if(Z == 1) cross = fGheisha->GetElasticCrossSection(dp, Z, A);
     else if(ekin > thEnergy) {
-      cross = theFac[iz]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
+      cross = theFac[Z]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
     } else {
       cross = fUPi->GetElasticCrossSection(dp, Z, A);
@@ -136,5 +138,5 @@
   } else {
     if(hasGlauber && ekin > thEnergy) {
-      cross = theFac[iz]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
+      cross = theFac[Z]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
     } else if(fGheisha->IsApplicable(dp, Z, A)) {
       cross = fGheisha->GetElasticCrossSection(dp, Z, A);
@@ -182,5 +184,5 @@
 
   G4NistManager* nist = G4NistManager::Instance();
-  G4double A = nist->GetAtomicMassAmu(2);
+  G4int A = G4lrint(nist->GetAtomicMassAmu(2));
 
   if(fGlauber->IsZAApplicable(&dp, 2.0, A)) {
@@ -193,17 +195,17 @@
 
       G4double Z = G4double(iz);
-      A = nist->GetAtomicMassAmu(iz);
-      csup = fGlauber->GetElasticGlauberGribov(&dp, Z, A);
+      A = G4lrint(nist->GetAtomicMassAmu(iz));
+      csup = fGlauber->GetElasticGlauberGribov(&dp, iz, A);
       // proton and neutron
       if(fNucleon) { 
-	csdn = fNucleon->GetElasticCrossSection(&dp, Z, A);
+	csdn = fNucleon->GetElasticCrossSection(&dp, iz, A);
 
 	// pions
       } else if(fUPi) {
-	csdn = fUPi->GetElasticCrossSection(&dp, Z, A);
+	csdn = fUPi->GetElasticCrossSection(&dp, iz, A);
 
 	// other
-      } else if(fGheisha->IsApplicable(&dp, Z, A)) {
-	csdn = fGheisha->GetElasticCrossSection(&dp, Z, A);
+      } else if(fGheisha->IsApplicable(&dp, iz, A)) {
+	csdn = fGheisha->GetElasticCrossSection(&dp, iz, A);
 
       } else {
@@ -217,5 +219,3 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-
+
Index: trunk/source/processes/hadronic/cross_sections/src/G4UInelasticCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4UInelasticCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4UInelasticCrossSection.cc	(revision 1340)
@@ -78,8 +78,8 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4bool G4UInelasticCrossSection::IsZAApplicable(const G4DynamicParticle* dp, 
-						G4double Z, G4double A)
+
+G4bool
+G4UInelasticCrossSection::IsIsoApplicable(const G4DynamicParticle* dp, 
+                                          G4int Z, G4int A)
 {
   G4bool res = false;
@@ -94,30 +94,30 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4UInelasticCrossSection::GetCrossSection(const G4DynamicParticle* dp, 
-						   const G4Element* elm, 
-						   G4double temp)
-{
-  return GetIsoZACrossSection(dp, elm->GetZ(), elm->GetN(), temp);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4UInelasticCrossSection::GetIsoZACrossSection(const G4DynamicParticle* dp, 
-							G4double Z,
-							G4double A, 
-							G4double)
+
+G4double
+G4UInelasticCrossSection::GetCrossSection(const G4DynamicParticle* dp, 
+					  const G4Element* elm, 
+				          G4double temp)
+{
+  G4int Z = G4lrint(elm->GetZ());
+  G4int N = G4lrint(elm->GetN());
+  return GetIsoZACrossSection(dp, Z, N, temp);
+}
+
+
+G4double
+G4UInelasticCrossSection::GetZandACrossSection(const G4DynamicParticle* dp, 
+					       G4int Z, G4int A, G4double)
 {
   G4double cross = 0.0;
   G4double ekin = dp->GetKineticEnergy();
-  G4int iz = G4int(Z);
-  if(iz > 92) iz = 92;
+  //  G4int iz = G4int(Z);
+  if(Z > 92) Z = 92;
 
     // proton and neutron
   if(fNucleon) { 
-    if(iz == 1) cross = fGheisha->GetInelasticCrossSection(dp, Z, A);
+    if(Z == 1) cross = fGheisha->GetInelasticCrossSection(dp, Z, A);
     else if(ekin > thEnergy) {
-      cross = theFac[iz]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
+      cross = theFac[Z]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
     } else {
       cross = fNucleon->GetIsoZACrossSection(dp, Z, A);
@@ -126,7 +126,7 @@
     // pions
   } else if(fUPi) {
-    if(iz == 1) cross = fGheisha->GetInelasticCrossSection(dp, Z, A);
+    if(Z == 1) cross = fGheisha->GetInelasticCrossSection(dp, Z, A);
     else if(ekin > thEnergy) {
-      cross = theFac[iz]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
+      cross = theFac[Z]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
     } else {
       cross = fUPi->GetInelasticCrossSection(dp, Z, A);
@@ -136,5 +136,5 @@
   } else {
     if(hasGlauber && ekin > thEnergy) {
-      cross = theFac[iz]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
+      cross = theFac[Z]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
     } else if(fGheisha->IsApplicable(dp, Z, A)){
       cross = fGheisha->GetInelasticCrossSection(dp, Z, A);
@@ -153,5 +153,4 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
 void G4UInelasticCrossSection::BuildPhysicsTable(const G4ParticleDefinition& p)
@@ -173,6 +172,4 @@
 
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
 void G4UInelasticCrossSection::Initialise(const G4ParticleDefinition* p) 
 {
@@ -182,7 +179,7 @@
 
   G4NistManager* nist = G4NistManager::Instance();
-  G4double A = nist->GetAtomicMassAmu(2);
-
-  if(fGlauber->IsZAApplicable(&dp, 2.0, A)) {
+  G4int A = G4lrint(nist->GetAtomicMassAmu(2));
+
+  if(fGlauber->IsIsoApplicable(&dp, 2, A)) {
     hasGlauber = true;
 
@@ -193,18 +190,18 @@
 
       G4double Z = G4double(iz);
-      A = nist->GetAtomicMassAmu(iz);
-      csup = fGlauber->GetInelasticGlauberGribov(&dp, Z, A);
+      A = G4lrint(nist->GetAtomicMassAmu(iz));
+      csup = fGlauber->GetInelasticGlauberGribov(&dp, iz, A);
 
       // proton and neutron
       if(fNucleon) { 
-	csdn = fNucleon->GetIsoZACrossSection(&dp, Z, A);
+	csdn = fNucleon->GetIsoZACrossSection(&dp, iz, A);
 
 	// pions
       } else if(fUPi) {
-	csdn = fUPi->GetInelasticCrossSection(&dp, Z, A);
+	csdn = fUPi->GetInelasticCrossSection(&dp, iz, A);
 
 	// other
-      } else if(fGheisha->IsApplicable(&dp, Z, A)) {
-	csdn = fGheisha->GetInelasticCrossSection(&dp, Z, A);
+      } else if(fGheisha->IsApplicable(&dp, iz, A)) {
+	csdn = fGheisha->GetInelasticCrossSection(&dp, iz, A);
 
       } else {
@@ -218,5 +215,2 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-
Index: trunk/source/processes/hadronic/cross_sections/src/G4UPiNuclearCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4UPiNuclearCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4UPiNuclearCrossSection.cc	(revision 1340)
@@ -60,6 +60,7 @@
 }
 
-G4double G4UPiNuclearCrossSection::GetElasticCrossSection(
-	 const G4DynamicParticle* dp, G4double Z, G4double A)
+G4double
+G4UPiNuclearCrossSection::GetElasticCrossSection(const G4DynamicParticle* dp,
+                                                 G4int Z, G4int A)
 {
   G4double cross = 0.0;
@@ -73,6 +74,7 @@
 }
 
-G4double G4UPiNuclearCrossSection::GetInelasticCrossSection(
-	 const G4DynamicParticle* dp, G4double Z, G4double A)
+G4double
+G4UPiNuclearCrossSection::GetInelasticCrossSection(const G4DynamicParticle* dp,
+                                                   G4int Z, G4int A)
 {
   G4double cross = 0.0;
@@ -82,5 +84,5 @@
   const G4ParticleDefinition* part = dp->GetDefinition();
 
-  // Coulomb barier
+  // Coulomb barrier
   if(part == piPlus) {
     if(ekin > elowest) {
@@ -101,9 +103,9 @@
 
 G4double G4UPiNuclearCrossSection::Interpolate(
-	 G4double Z, G4double A, G4double ekin, G4PhysicsTable* table)
+	 G4int Z, G4int A, G4double ekin, G4PhysicsTable* table)
 {
   G4double res = 0.0;
   G4int idx;
-  G4int iz = G4int(Z + 0.5);
+  G4int iz = Z;
   if(iz > 92) iz = 92;
   for(idx=0; idx<NZ; idx++) {if(theZ[idx] >= iz) break;}
@@ -123,6 +125,6 @@
     G4int iz1 = theZ[idx-1];
     G4double x1 = (((*table)[idx-1])->Value(ekin))*APower[iz]/APower[iz1];
-    G4double w1 = A - theA[idx-1];
-    G4double w2 = theA[idx] - A;
+    G4double w1 = G4double(A) - theA[idx-1];
+    G4double w2 = theA[idx] - G4double(A);
     res = (w1*x2 + w2*x1)/(w1 + w2); 
   }
